FROM henriqueflaviodev/oracle-client-11
COPY docker/*.ora ./
RUN bin/bash -c "mkdir -p $ORACLE_CONN; mv tnsnames.ora $ORACLE_CONN; mv sqlnet.ora $ORACLE_CONN"

RUN apt-get clean packages
RUN apt-get update &&\
    apt-get install -y apache2
RUN echo "export ORACLE_HOME=$ORACLE_HOME\nexport LD_LIBRARY_PATH=\$ORACLE_HOME/lib" >> /etc/apache2/envvars

ENV PHP_VERSION=7.1
RUN apt-get install -y apt-transport-https lsb-release ca-certificates wget php-pear git zip unzip
RUN wget -O /etc/apt/trusted.gpg.d/php.gpg https://packages.sury.org/php/apt.gpg &&\
    echo "deb https://packages.sury.org/php/ $(lsb_release -sc) main" > /etc/apt/sources.list.d/php.list &&\
    apt-get update
RUN apt-get install -y php$PHP_VERSION php$PHP_VERSION-xml php$PHP_VERSION-fpm php$PHP_VERSION-dev php$PHP_VERSION-mbstring php$PHP_VERSION-curl php$PHP_VERSION-soap php$PHP_VERSION-gd php$PHP_VERSION-imagick php$PHP_VERSION-mysql php$PHP_VERSION-cli php$PHP_VERSION-cgi php$PHP_VERSION-common php$PHP_VERSION-json php$PHP_VERSION-imagick php$PHP_VERSION-mysql php$PHP_VERSION-cli php$PHP_VERSION-cgi php$PHP_VERSION-common php$PHP_VERSION-xmlrpc php$PHP_VERSION-zip php$PHP_VERSION-opcache php$PHP_VERSION-readline php$PHP_VERSION-bcmath php$PHP_VERSION-bz2 php$PHP_VERSION-intl
RUN update-alternatives --set php /usr/bin/php$PHP_VERSION
RUN apt-get install -y libapache2-mod-php$PHP_VERSION
RUN a2enmod proxy_fcgi setenvif &&\
    a2enconf php$PHP_VERSION-fpm &&\
    a2enmod rewrite

ENV OCI8_VERSION=oci8-2.2.0
RUN echo "instantclient,/usr/lib/oracle/11.2/client64/lib" >> ./answer-oci
RUN pecl channel-update pecl.php.net &&\
    pecl install $OCI8_VERSION < ./answer-oci &&\
    echo "extension=oci8.so" > /etc/php/$PHP_VERSION/mods-available/oci8.ini &&\
    ln -s /etc/php/$PHP_VERSION/mods-available/oci8.ini /etc/php/$PHP_VERSION/cli/conf.d/20-oci8.ini &&\
    ln -s /etc/php/$PHP_VERSION/mods-available/oci8.ini /etc/php/$PHP_VERSION/fpm/conf.d/20-oci8.ini &&\
    ln -s /etc/php/$PHP_VERSION/mods-available/oci8.ini /etc/php/$PHP_VERSION/apache2/conf.d/20-oci8.ini &&\
    rm -f ./answer-oci

RUN php -r "copy('https://getcomposer.org/installer', 'composer-setup.php');" &&\
    php -r "if (hash_file('sha384', 'composer-setup.php') === '756890a4488ce9024fc62c56153228907f1545c228516cbf63f885e036d37e9a59d27d63f46af1d4d07ee0f76181c7d3') { echo 'Installer verified'; } else { echo 'Installer corrupt'; unlink('composer-setup.php'); } echo PHP_EOL;" &&\
    php composer-setup.php --install-dir=/usr/bin --filename=composer &&\
    php -r "unlink('composer-setup.php');"

ENV PHP_DATE_VERSION=20160303
ENV XDEBUG_VERSION=2.9.8
ENV XDEBUG_CONTENT="\n\n[XDEBUG]\nzend_extension=\"/usr/lib/php/$PHP_DATE_VERSION/xdebug.so\""

RUN pecl install xdebug-$XDEBUG_VERSION &&\
    echo -e $XDEBUG_CONTENT >> /etc/php/$PHP_VERSION/apache2/php.ini &&\
    echo $XDEBUG_CONTENT > /etc/php/$PHP_VERSION/mods-available/xdebug.ini &&\
    ln -s /etc/php/$PHP_VERSION/mods-available/xdebug.ini /etc/php/$PHP_VERSION/cli/conf.d/xdebug.ini &&\
    echo "error_reporting=E_ALL" >> /etc/php/$PHP_VERSION/apache2/php.ini &&\
    echo "display_startup_errors=On" >> /etc/php/$PHP_VERSION/apache2/php.ini &&\
    echo "display_errors=On" >> /etc/php/$PHP_VERSION/apache2/php.ini &&\
    echo "xdebug.remote_enable=1" >> /etc/php/$PHP_VERSION/apache2/php.ini &&\
    echo "xdebug.remote_host=host.docker.internal" >> /etc/php/$PHP_VERSION/apache2/php.ini &&\
    echo "xdebug.remote_port=9001" >> /etc/php/$PHP_VERSION/apache2/php.ini &&\
    echo "xdebug.remote_handler=dbgp" >> /etc/php/$PHP_VERSION/apache2/php.ini &&\
    echo "xdebug.remote_autostart=1" >> /etc/php/$PHP_VERSION/apache2/php.ini &&\
    echo "xdebug.remote_connect_back=0" >> /etc/php/$PHP_VERSION/apache2/php.ini &&\
    echo "xdebug.idekey=docker" >> /etc/php/$PHP_VERSION/apache2/php.ini

ENV APP_PATH=/var/www/html
WORKDIR $APP_PATH
COPY ./docker/000-default.conf /etc/apache2/sites-available/000-default.conf
COPY ./docker/.ssh/* /root/.ssh/
RUN chmod 400 /root/.ssh/id_rsa

RUN curl -sL https://deb.nodesource.com/setup_16.x | bash &&\
    apt install nodejs -y

ENV APP_SERVER_NAME=gecv2-local
RUN echo "ServerName $APP_SERVER_NAME" >> /etc/apache2/apache2.conf
RUN apachectl configtest

ADD ./entrypoint.sh /usr/local/bin/entrypoint.sh
RUN sed -i -e 's/\r$//' /usr/local/bin/entrypoint.sh
CMD /bin/bash -c "entrypoint.sh"